/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DEBUGEVENT_20060720_H_
#define DEBUGEVENT_20060720_H_

#include <sys/wait.h>

struct DebugEvent {
	int status;
	
	enum REASON {
		EVENT_EXITED,	// exited normally
		EVENT_SIGNALED,	// application recieved a signal
		EVENT_STOPPED,	// we recieved an event
		EVENT_UNKNOWN
	};

	DebugEvent();
	DebugEvent(int s);

	int exitStatus() const;
	int exitSignal() const;
	int stopSignal() const;
	REASON reason() const;
	

	bool exited() const;
	bool signaled() const;
	bool stopped() const;
	
	
	enum SIGNALS {
		sigsegv	= SIGSEGV,
		sigill	= SIGILL,
		sigfpe	= SIGFPE,
		sigstop	= SIGSTOP,
		sigtrap	= SIGTRAP,
		sigchld	= SIGCHLD,
		sigcont	= SIGCONT,
		sigkill	= SIGKILL
	};
};

#endif

